#include "iostream.h"
#include "conio.h"
#include "stdlib.h"
#include "stdio.h"
#include "i86.h"
#include "windows.h"
#define data    0x378
#define status  0x379
#define control 0x37a
#define pin1    0
#define pin14   1
#define pin16   2       //not inverted
#define pin17   3
#define bidir   5
#define drop_pin1       raisebit(pin1)
#define raise_pin1      dropbit(pin1)
#define drop_pin14      raisebit(pin14)
#define raise_pin14     dropbit(pin14)
#define drop_pin16      dropbit(pin16)
#define raise_pin16     raisebit(pin16)
#define drop_pin17      raisebit(pin17)
#define raise_pin17     dropbit(pin17)
#define set_bidir       raisebit(bidir)

#define drop_DUMPST       raisebit(pin1)
#define raise_DUMPST      dropbit(pin1)
#define drop_MRESET      raisebit(pin14)
#define raise_MRESET     dropbit(pin14)
#define drop_RESET      dropbit(pin16)
#define raise_RESET     raisebit(pin16)
#define drop_PAUSE      raisebit(pin17)
#define raise_PAUSE     dropbit(pin17)



unsigned int shadow=0;

void raisebit(int bit){
        shadow |= (1 << bit);
        outp(control,shadow);
}

void dropbit(int bit){
        shadow &= ~(1 << bit);
        outp(control,shadow);
}

int main()
{
        unsigned long rom_address;
        unsigned char rom_data;
        int progress_count;

        unsigned int i;
        FILE *disk_file;
        cout<<"Test LPT port with GiveIO.sys"<<endl;
        HANDLE h=CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
                               OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        if (h==INVALID_HANDLE_VALUE)
        {
                cout<<"Error! Can't open driver! Press any key to exit... "<<endl;
                getch();
                return(0);
        }


//        outp(control,0x20);


        if ((disk_file = fopen("eec_rom.bin", "wb")) == NULL)
        {
                printf("Unable to open file eec_rom.bin - check disk\n");
                return(1);
        }




        set_bidir;


        raise_DUMPST;
        drop_RESET;
        drop_PAUSE;
        drop_MRESET;
        delay(250);

        raise_RESET;
    delay(1);

        raise_MRESET;
    delay(250);
    delay(250);




        progress_count = 0;
        for (rom_address = 0L; rom_address<(32*1024L); rom_address++)
        {
                // display progress every 0x100 bytes
                if (progress_count==0x0100)
                {
                        printf("\rSaving ROM location 0x%05lX...", rom_address);
                        progress_count = 0;
                }

                // save ROM data at current address to file
                rom_data = inp(data);
                fputc(rom_data, disk_file);
                progress_count++;

        // increment the ROM's internal address counter
//        strobe_DUMPST();
        drop_DUMPST;
        raise_DUMPST;
        }

        fclose(disk_file);
        printf("\rSaving ROM location 0x%05lX... %6ld bytes OK!\n", rom_address-1, rom_address);
        return(0);



}
